searchData={"items":[{"type":"module","title":"Membrane.RTC.Engine.Endpoint.Recording","doc":"An Endpoint responsible for saving incoming tracks to pointed storages.","ref":"Membrane.RTC.Engine.Endpoint.Recording.html"},{"type":"module","title":"Bin options - Membrane.RTC.Engine.Endpoint.Recording","doc":"Passed via struct `t:Membrane.RTC.Engine.Endpoint.Recording.t/0`\n\n- `rtc_engine`  \n\n  ```\n  pid()\n  ```\n  \n  ***Required***  \n  Pid of parent Engine\n\n\n- `stores`  \n\n  ```\n  [{storage(), storage_opts()}]\n  ```\n  \n  ***Required***  \n  A list of stores that the recorded streams will be uploaded to.\n  Should implement `Membrane.RTC.Engine.Endpoint.Recording.Storage` behaviour.\n\n\n\n- `recording_id`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  Recording id that will be saved along with report\n\n\n\n- `subscribe_mode`  \n\n  ```\n  :auto | :manual\n  ```\n  \n  Default value: `:auto`  \n  Whether tracks should be subscribed automatically when they're ready.\n  If set to `:manual`, Recording endpoint will subscribe only to tracks from endpoints sent using message:\n  `{:subscribe, endpoints}`","ref":"Membrane.RTC.Engine.Endpoint.Recording.html#module-bin-options"},{"type":"module","title":"Pads - Membrane.RTC.Engine.Endpoint.Recording","doc":"### `:input`\n\nAccepted formats:\n```\nMembrane.RTP\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`","ref":"Membrane.RTC.Engine.Endpoint.Recording.html#module-pads"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTC.Engine.Endpoint.Recording.html#options/0"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.storage/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.html#t:storage/0"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.storage_opts/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.html#t:storage_opts/0"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.subscribe/3","doc":"Subscribe Recording endpoint to tracks from endpoints.\n\nIt is only valid to use when Recording has `subscribe_mode` set to :manual.","ref":"Membrane.RTC.Engine.Endpoint.Recording.html#subscribe/3"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.t/0","doc":"Struct containing options for `Membrane.RTC.Engine.Endpoint.Recording`","ref":"Membrane.RTC.Engine.Endpoint.Recording.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Endpoint.Recording.Metrics","doc":"Defines list of metrics, that Reporter instance can aggregate by listening on events emitted in RTC Engine.\nSuggested Reporter implementation is `Membrane.TelemetryMetrics.Reporter` from\n[`membrane_telemetry_metrics`](https://github.com/membraneframework/membrane_telemetry_metrics).\nYou can see usage example in [`fishjam`](https://github.com/fishjam-cloud/fishjam).\n\nSee also `Metrics` guide for more details and example report that you can obtain with\n`Membrane.TelemetryMetrics.Reporter`.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Metrics.html"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Metrics.metrics/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Metrics.html#metrics/0"},{"type":"module","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter","doc":"Module responsible for creating report with information needed to decode recorded streams.\n\nEach stream is represented as a track that includes the following fields:\n  * `type` - Specifies either `:video` or `:audio`.\n  * `encoding` - Necessary for decoding.\n  * `offset` - Represents the offset compared to the first track (the first track always has an offset of 0).\n    The the offset is calculated based on the `handle_pad_added` call time.\n  * `start_timestamp` - Specifies the RTP timestamp of the first buffer.\n  * `start_timestamp_wallclock` - Denotes the wallclock timestamp of the first buffer.\n  * `end_timestamp` - Indicates the RTP timestamp of the last buffer.\n  * `clock_rate` - Necessary for decoding.\n  * `metadata` - Contains custom data attached by peer to the track.\n  * `origin` - Specifies the component that published the track.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.add_track/4","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#add_track/4"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#child_spec/1"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.end_timestamp/3","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#end_timestamp/3"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.filename/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#t:filename/0"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.get_report/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#get_report/1"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.report/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#t:report/0"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.rtcp_packet/3","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#rtcp_packet/3"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.start/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#start/1"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.start_timestamp/3","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#start_timestamp/3"},{"type":"opaque","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.state/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#t:state/0"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.stop/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#stop/1"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.track_report/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Reporter.html#t:track_report/0"},{"type":"behaviour","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage","doc":"An interface for Recording endpoint storage configuration.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.html"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.files/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.html#t:files/0"},{"type":"callback","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.get_sink/2","doc":"Callback invoked when a new track is added to `RecordingEndpoint`.\nIt should return a struct that will be further added as a child to the spec.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.html#c:get_sink/2"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.object_config/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.html#t:object_config/0"},{"type":"callback","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.on_close/3","doc":"This callback gets invoked exclusively when `FileStorage` is in use and a recording session is being closed.\nWithin this callback, you can perform the following actions:\n\n  * Clean up all resources\n  * Attempt to rectify any discrepancies between the saved objects and local files\n\nIf error is returned report won't be sent to the storage.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.html#c:on_close/3"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.recording_config/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.html#t:recording_config/0"},{"type":"callback","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.save_object/2","doc":"Callback invoked once all tracks have been processed by `RecordingEndpoint`.\nThe returned object can be of two types:\n\n  * `report` - a file containing all the necessary information for deserializing the processed tracks.\n  * `recording` - a file that captures a complete track recording.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.html#c:save_object/2"},{"type":"module","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.File","doc":"`Membrane.RTC.Engine.Endpoint.Recording.Storage` implementation that saves the stream to files locally.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.File.html"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.File.list_files/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.File.html#list_files/1"},{"type":"module","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3","doc":"`Membrane.RTC.Engine.Endpoint.Recording.Storage` implementation that saves the stream to the pointed AWS S3 bucket.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.html"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.create_aws_config/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.html#create_aws_config/1"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.credentials_t/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.html#t:credentials_t/0"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.storage_opts/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.html#t:storage_opts/0"},{"type":"module","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink","doc":"Element that saves given stream to S3 bucket in real time.","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.html"},{"type":"module","title":"Element options - Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink","doc":"Passed via struct `t:Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.t/0`\n\n- `credentials`  \n\n  ```\n  credentials()\n  ```\n  \n  ***Required***  \n  Credentials with all information needed to get access to pointed AWS S3 bucket.\n\n\n- `path`  \n\n  ```\n  Path.t()\n  ```\n  \n  ***Required***  \n  Path to file in a bucket\n\n\n\n- `chunk_size`  \n\n  ```\n  pos_integer()\n  ```\n  \n  ***Required***  \n  Size of a single chunk that will be sent to s3 bucket","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.html#module-element-options"},{"type":"module","title":"Pads - Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink","doc":"### `:input`\n\nAccepted formats:\n```\n_any\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.html#module-pads"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.credentials/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.html#t:credentials/0"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.html#options/0"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.t/0","doc":"Struct containing options for `Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink`","ref":"Membrane.RTC.Engine.Endpoint.Recording.Storage.S3.Sink.html#t:t/0"},{"type":"extras","title":"Membrane RTC Engine Recording Endpoint","doc":"# Membrane RTC Engine Recording Endpoint\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_rtc_engine_recording.svg)](https://hex.pm/packages/membrane_rtc_engine_recording)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_rtc_engine_recording)\n[![codecov](https://codecov.io/gh/fishjam-cloud/membrane_rtc_engine/graph/badge.svg?token=ZPHQVR6WXB)](https://codecov.io/gh/fishjam-cloud/membrane_rtc_engine)\n[![CircleCI](https://dl.circleci.com/status-badge/img/circleci/GYdMJX3ERMbXTmauvqgRKE/7B94kqtbCjtAfbnStg3PLn/tree/master.svg?style=svg)](https://dl.circleci.com/status-badge/redirect/circleci/GYdMJX3ERMbXTmauvqgRKE/7B94kqtbCjtAfbnStg3PLn/tree/master)\n\nRecording Endpoint for the [Membrane RTC Engine](https://github.com/fishjam-cloud/membrane_rtc_engine)","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane RTC Engine Recording Endpoint","doc":"The package can be installed by adding `membrane_rtc_engine_recording` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:membrane_rtc_engine_recording, \"~> 0.3.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Copyright and License - Membrane RTC Engine Recording Endpoint","doc":"Copyright 2024, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_rtc_engine)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_rtc_engine)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.3.0 - Changelog","doc":"* Update deps [#5](https://github.com/fishjam-cloud/membrane_rtc_engine/pull/5)\n* Update membrane core [#45](https://github.com/fishjam-cloud/membrane_rtc_engine/pull/45)\n* Update membrane rtp plugins [#46](https://github.com/fishjam-cloud/membrane_rtc_engine/pull/46)","ref":"changelog.html#0-3-0"},{"type":"extras","title":"0.2.0 - Changelog","doc":"* Synchronize tracks based on RTCP sender reports [#393](https://github.com/fishjam-dev/membrane_rtc_engine/pull/393)\n* Fix setting last buffer timestamp [#394](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/394)\n* Fix rtcp synchronization [#397](https://github.com/fishjam-dev/membrane_rtc_engine/pull/397)\n* Don't list S3 object if no files added in recording [#396](https://github.com/fishjam-dev/membrane_rtc_engine/pull/396)\n* Refactor rtcp synchronization [#399](https://github.com/fishjam-dev/membrane_rtc_engine/pull/399)\n* Update dependencies [#2](https://github.com/fishjam-cloud/membrane_rtc_engine/pull/2)","ref":"changelog.html#0-2-0"},{"type":"extras","title":"0.1.0 - Changelog","doc":"* Initial release [#356](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/356)\n* Add crash groups, fix adding nonexistent tracks to state, fix READMEs [#366](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/366)\n* Add working AWS storage [#369](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/369)\n* Refactor storage API [#375](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/375)\n* Update deps [#374](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/374)\n* Extend report created by RecordingEndpoint [#376](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/376)\n* Add cleanup function and metrics to s3 sink [#378](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/378)\n* Save report only when it contains any track [#379](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/379)\n* Add recovery mechanism to s3 sink [#380](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/380)\n* Endpoint sends `:finished` after all input tracks unlink and update the use of Engine.subscribe [#381](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/381)\n* Use engine manual and auto subscribe mode. [#383](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/383)\n* Fix membrane_core version used in mixfile [#385](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/385)\n* Change use of ResourceGuard [#386](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/386)\n* Add origin to the report [#387](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/387)\n* Change s3 on close mechanism [#388](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/388)\n* Fix nils in recording report [#389](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/389)","ref":"changelog.html#0-1-0"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2024 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}